#include <stdio.h>
#include <stdlib.h>

void copy(char *from_file, char *to_file) {
  FILE *from, *to;
  char ch;
  from = fopen(from_file,"rb");
  if (!from) {
    printf("Erreur : impossible d'ouvrir en lecture \"%s\"\n",from_file);
    exit(1);
  }
  to = fopen(to_file,"wb");
  if (!to) {
    printf("Erreur : impossible d'ouvrir en écriture \"%s\"\n",to_file);
    exit(1);
  }
  while (!feof(from)) {
    ch = fgetc(from);
    if (ferror(from)) {
      printf("Erreur en lecture de \"%s\"\n",from_file);
      exit(1);
    }
    if (!feof(from)) fputc(ch,to);
    if (ferror(to)) {
      printf("Erreur en écriture de \"%s\"\n",to_file);
      exit(1);
    }
  }
  fclose(from);
  fclose(to);
}

void affiche(char *nom_bd) {
  FILE *bd;
  bd = fopen(nom_bd,"rb");
  unsigned long p;
  fread(&p,sizeof(unsigned long),1,bd);
  printf("maximum : %lu\n2 ",p);

  fread(&p,sizeof(unsigned long),1,bd);
  while(!feof(bd)) {
    printf("%lu ",p);
    fread(&p,sizeof(unsigned long),1,bd);
  }
  printf("\n");
}

/*
 * crée ou met à jour la base de données des premiers
 * Si aucun fichier avec nom @nom_bd existe, il est créé en contenant
 * @n, et tous les premiers plus petits que @n
 * après.
 * Si @nom_bd existe, on va lire le premier entier dans le fichier,
 * et on va ajouter les premiers qui manquent (en changeant en @n la 
 * tête du fichier)
 * name : update
 * @nom_bd : nom du fichier
 * @n : on va créer les premiers plus petits que @n
 */
void update(char *nom_bd, unsigned long n) {
  FILE *bd;
  unsigned long i, p;
  bd = fopen(nom_bd,"r+b");
  if(!bd) {
    i = 3;
    bd = fopen(nom_bd,"w+b");
  } else {
    fread(&i,sizeof(unsigned long),1,bd);
    rewind(bd);
  }
  if (!bd) {
    printf("Impossible d'ouvrir \"%s\" en écriture !\n",nom_bd);
    exit(1);
  }
  if (i >= n) {
    fclose(bd);
    return;
  }
  fwrite(&n,sizeof(unsigned long),1,bd);
  long pos = ftell(bd); /* on sauvegarde la position dans le fichier
                         * pour y retourner
                         */
  if(i%2 == 0) i++; /* si le nombre du quel on doit commencer est pair
                     * on prend l'impair successif
                     */
  for( ; i < n; i += 2) {
    fread(&p,sizeof(unsigned long),1,bd);
    while(!feof(bd)) {
      if (i%p == 0) {
        flag = 0;
        break;
      }
      fread(&p,sizeof(unsigned long),1,bd);
    }
    if (feof(bd)) { /* si feof, cela veut dire que aucun premier dans
                     * la base de données ne divide i
                     * donc i est premier et il faut l'ajouter
                     */
      fwrite(&i,sizeof(unsigned long),1,bd);
    }
    fseek(bd,pos,SEEK_SET); /* on revien au debut du fichier,
                             * juste après la tête n
                             * (on pourrait aussi faire
                             * frewind(bd) et lire un entier
                             */
  }
}      

void create(char *nom_bd,unsigned long n) {
  remove(nom_bd);
  update(nom_bd,n);
}
